library ieee;
use ieee.std_logic_1164.all;

--! \page pg_mypage My Page
--! Another page. Remove me and both brief and details on package my_pkg will work.
--!


--! \brief Package brief works without pg_mypage.
--! \details Package details removes all documentation for the package (but not the package body)
--! but only if I keep the page pg_mypage above, otherwise it works.
--! This text should not appear on the pg_mypage page, but it does.
package my_pkg is
  constant apa : integer := 3;   --! Monkey
  function hepp_hopp(constant s : in string) return string;   --! The very useful function of removing the last two characters. (package)
end my_pkg;

--! \brief Package body brief works.     
--! \details Package body details works. 
package body my_pkg is 

  --! \brief Function brief works.
  --! \details Function details breaks latex output.
  function hepp_hopp(constant s: in string) return string is
  begin
    return(s(s'left to s'right-2));
  end hepp_hopp;
  
end my_pkg;


library ieee;
use ieee.std_logic_1164.all;
use work.my_pkg.all;

--! \brief Entity brief works.
--! \details Entity details works. 
entity bosse is
    Port ( clk : in  STD_LOGIC;     --! clock
           rst : in  STD_LOGIC;		--! Reset
           i : in  STD_LOGIC;			--! Input
           o : out  STD_LOGIC);	--! Output
end bosse;

--! \brief Architecture brief works.
--! \details Architecture details works. 
architecture Behavioral of bosse is
	signal shortened : string(1 to 3) := hepp_hopp("12345");    --! Using the hepp_hopp function.
begin

  --! \brief  Process brief works
  --! \details Process details breaks latex output
  p0: process(clk)
  begin
    if rising_edge(clk) then
      if rst='1' then
        o <= '0';
      else      	
        o <= i;
      end if;
    end if;
  end process;

end Behavioral;
